"""Databases and datasets used in common tests"""

import yaml

YAML_LOADER = yaml.FullLoader


A_B_REGULAR_SOLUTION_TDB = """
ELEMENT A ALPHA 0.0 0.0 0.0 !
ELEMENT B ALPHA 0.0 0.0 0.0 !

TYPE_DEFINITION % SEQ *!

PHASE ALPHA % 1 1 !
CONSTITUENT ALPHA : A B : !

$ Default the lattice stability and regular solution parameter to zero
FUNCTION G_ALPHA_A 1 0.0; 10000 N !
FUNCTION G_ALPHA_B 1 0.0; 10000 N !
FUNCTION L_ALPHA 1 0.0; 10000 N !

$ Set the ALPHA lattice stability to zero
PARAMETER G(ALPHA,A;0) 1 G_ALPHA_A; 10000 N !
PARAMETER G(ALPHA,B;0) 1 G_ALPHA_B; 10000 N !
PARAMETER L(ALPHA,A,B;0) 1 L_ALPHA; 10000 N !
"""


CU_MG_TDB = """$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$
$ Date: 2017-09-27 21:10
$ Components: CU, MG, VA
$ Phases: CUMG2, FCC_A1, HCP_A3, LAVES_C15, LIQUID
$ Generated by brandon (pycalphad 0.5.2.post1)
$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$

ELEMENT CU BLANK 0 0 0 !
ELEMENT MG BLANK 0 0 0 !
ELEMENT VA BLANK 0 0 0 !

FUNCTION GFCCCU 298.15 GHSERCU#; 3200.0 N !
FUNCTION GFCCMG 298.15 -0.9*T + GHSERMG# + 2600; 3000.0 N !
FUNCTION GHCPCU 298.15 0.2*T + GHSERCU# + 600; 3200.0 N !
FUNCTION GHCPMG 298.15 GHSERMG#; 3000.0 N !
FUNCTION GHSERCU 298.15 1.29223E-7*T**3 - 0.00265684*T**2 - 24.112392*T*LN(T)
   + 130.485235*T - 7770.458 + 52478*T**(-1); 1357.77 Y -31.38*T*LN(T) +
   183.803828*T - 13542.026 + 3.64167E+29*T**(-9); 3200.0 N !
FUNCTION GHSERMG 298.15 -1.393669E-6*T**3 + 0.0004858*T**2 -
   26.1849782*T*LN(T) + 143.675547*T - 8367.34 + 78950*T**(-1); 923.0 Y
   -34.3088*T*LN(T) + 204.716215*T - 14130.185 + 1.038192E+28*T**(-9); 3000.0
   N !
FUNCTION GHSERVA 1 0; 10000 N !
FUNCTION GLAVCU 298.15 3.87669E-7*T**3 - 0.00797052*T**2 - 72.337176*T*LN(T)
   + 391.455705*T - 8311.374 + 157434*T**(-1); 1357.77 Y -94.14*T*LN(T) +
   551.411484*T - 25626.078 + 1.092501E+30*T**(-9); 3200.0 N !
FUNCTION GLAVMG 298.15 -4.181007E-6*T**3 + 0.0014574*T**2 -
   78.5549346*T*LN(T) + 431.026641*T - 10102.02 + 236850*T**(-1); 923.0 Y
   -102.9264*T*LN(T) + 614.148645*T - 27390.555 + 3.11458E+28*T**(-9); 3000.0
   N !
FUNCTION GLIQCU 298.15 -5.8489E-21*T**7 - 9.511904*T + GHSERCU# + 12964.735;
   1357.77 Y -31.38*T*LN(T) + 173.881484*T - 46.545; 3200.0 N !
FUNCTION GLIQMG 298.15 -8.0176E-20*T**7 - 8.83693*T + GHSERMG# + 8202.243;
   923.0 Y -34.3088*T*LN(T) + 195.324057*T - 5439.869; 3000.0 N !
FUNCTION VV0000 1 -32429.6; 10000 N !
FUNCTION VV0001 1 -4.12896; 10000 N !
FUNCTION VV0002 1 8.2363; 10000 N !
FUNCTION VV0003 1 -14.0865; 10000 N !
FUNCTION VV0004 1 -11.2723; 10000 N !
FUNCTION VV0005 1 11.1114; 10000 N !
FUNCTION VV0006 1 -8.29125; 10000 N !
FUNCTION VV0007 1 -14.9845; 10000 N !
FUNCTION VV0008 1 -40470.2; 10000 N !
FUNCTION VV0009 1 104160.0; 10000 N !
FUNCTION VV0010 1 17766.4; 10000 N !
FUNCTION VV0011 1 150325.0; 10000 N !
FUNCTION VV0012 1 21243.0; 10000 N !
FUNCTION VV0013 1 214671.0; 10000 N !
FUNCTION VV0014 1 14321.1; 10000 N !
FUNCTION VV0015 1 -4923.18; 10000 N !
FUNCTION VV0016 1 -1962.8; 10000 N !
FUNCTION VV0017 1 -31626.6; 10000 N !

TYPE_DEFINITION % SEQ * !
DEFINE_SYSTEM_DEFAULT ELEMENT 2 !
DEFAULT_COMMAND DEFINE_SYSTEM_ELEMENT VA !

PHASE CUMG2 %  2 1 2 !
CONSTITUENT CUMG2 :CU:MG: !

PHASE FCC_A1 %  2 1 1 !
CONSTITUENT FCC_A1 :CU,MG:VA: !

PHASE HCP_A3 %  2 1 0.5 !
CONSTITUENT HCP_A3 :CU,MG:VA: !

PHASE LAVES_C15 %  2 2 1 !
CONSTITUENT LAVES_C15 :CU,MG:CU,MG: !

PHASE LIQUID %  1 1 !
CONSTITUENT LIQUID :CU,MG: !



$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$
$                                     CU                                     $
$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$

PARAMETER G(FCC_A1,CU:VA;0) 1 GFCCCU#; 10000 N !
PARAMETER G(HCP_A3,CU:VA;0) 1 GHCPCU#; 10000 N !
PARAMETER G(LAVES_C15,CU:CU;0) 1 GLAVCU#; 10000 N !
PARAMETER G(LIQUID,CU;0) 1 GLIQCU#; 10000 N !


$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$
$                                     MG                                     $
$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$

PARAMETER G(FCC_A1,MG:VA;0) 1 GFCCMG#; 10000 N !
PARAMETER G(HCP_A3,MG:VA;0) 1 GHCPMG#; 10000 N !
PARAMETER G(LAVES_C15,MG:MG;0) 1 GLAVMG#; 10000 N !
PARAMETER G(LIQUID,MG;0) 1 GLIQMG#; 10000 N !


$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$
$                                   CU-MG                                    $
$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$

PARAMETER G(CUMG2,CU:MG;0) 1 GHSERCU# + 2*GHSERMG# + VV0000#; 10000 N !
PARAMETER L(FCC_A1,CU,MG:VA;0) 1 VV0003#; 10000 N !
PARAMETER L(FCC_A1,CU,MG:VA;1) 1 VV0002#; 10000 N !
PARAMETER L(FCC_A1,CU,MG:VA;2) 1 VV0001#; 10000 N !
PARAMETER L(HCP_A3,CU,MG:VA;0) 1 VV0007#; 10000 N !
PARAMETER L(HCP_A3,CU,MG:VA;1) 1 VV0006#; 10000 N !
PARAMETER L(HCP_A3,CU,MG:VA;2) 1 VV0005#; 10000 N !
PARAMETER L(HCP_A3,CU,MG:VA;3) 1 VV0004#; 10000 N !
PARAMETER G(LAVES_C15,CU:MG;0) 1 2*GHSERCU# + GHSERMG# + VV0008#; 10000 N !
PARAMETER G(LAVES_C15,MG:CU;0) 1 GHSERCU# + 2*GHSERMG# + VV0009#; 10000 N !
PARAMETER L(LAVES_C15,CU:CU,MG;0) 1 VV0010#; 10000 N !
PARAMETER L(LAVES_C15,CU,MG:CU;0) 1 VV0011#; 10000 N !
PARAMETER L(LAVES_C15,CU,MG:MG;0) 1 VV0012#; 10000 N !
PARAMETER L(LAVES_C15,MG:CU,MG;0) 1 VV0013#; 10000 N !
PARAMETER L(LIQUID,CU,MG;0) 1 VV0017#; 10000 N !
PARAMETER L(LIQUID,CU,MG;1) 1 VV0016#; 10000 N !
PARAMETER L(LIQUID,CU,MG;2) 1 VV0015#; 10000 N !
PARAMETER L(LIQUID,CU,MG;3) 1 VV0014#; 10000 N !

"""

CU_MG_TDB_FCC_ONLY = """$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$
$ Cu-Mg, FCC only
$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$

ELEMENT CU BLANK 0 0 0 !
ELEMENT MG BLANK 0 0 0 !
ELEMENT VA BLANK 0 0 0 !

FUNCTION GFCCCU 298.15 GHSERCU#; 3200.0 N !
FUNCTION GFCCMG 298.15 -0.9*T + GHSERMG# + 2600; 3000.0 N !
FUNCTION GHSERCU 298.15 1.29223E-7*T**3 - 0.00265684*T**2 - 24.112392*T*LN(T)
   + 130.485235*T - 7770.458 + 52478*T**(-1); 1357.77 Y -31.38*T*LN(T) +
   183.803828*T - 13542.026 + 3.64167E+29*T**(-9); 3200.0 N !
FUNCTION GHSERMG 298.15 -1.393669E-6*T**3 + 0.0004858*T**2 -
   26.1849782*T*LN(T) + 143.675547*T - 8367.34 + 78950*T**(-1); 923.0 Y
   -34.3088*T*LN(T) + 204.716215*T - 14130.185 + 1.038192E+28*T**(-9); 3000.0
   N !
FUNCTION GHSERVA 1 0; 10000 N !
FUNCTION VV0001 1 -4.12896; 10000 N !
FUNCTION VV0002 1 8.2363; 10000 N !
FUNCTION VV0003 1 -14.0865; 10000 N !

TYPE_DEFINITION % SEQ * !
DEFINE_SYSTEM_DEFAULT ELEMENT 2 !
DEFAULT_COMMAND DEFINE_SYSTEM_ELEMENT VA !

PHASE FCC_A1 %  2 1 1 !
CONSTITUENT FCC_A1 :CU,MG:VA: !

PARAMETER G(FCC_A1,CU:VA;0) 1 GFCCCU#; 10000 N !
PARAMETER G(FCC_A1,MG:VA;0) 1 GFCCMG#; 10000 N !
PARAMETER L(FCC_A1,CU,MG:VA;0) 1 VV0003#; 10000 N !
PARAMETER L(FCC_A1,CU,MG:VA;1) 1 VV0002#; 10000 N !
PARAMETER L(FCC_A1,CU,MG:VA;2) 1 VV0001#; 10000 N !

"""

CU_MG_TDB_ASSOC = """$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$
$ ASSOC TDB FROM CU_MG
$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$

ELEMENT CU BLANK 0 0 0 !
ELEMENT MG BLANK 0 0 0 !
ELEMENT VA BLANK 0 0 0 !

SPECIES COMPA CU1.0 !
SPECIES COMPB CU1MG2.0 !
SPECIES COMPC MG1.0 !

FUNCTION GFCCCU 298.15 GHSERCU#; 3200.0 N !
FUNCTION GFCCMG 298.15 -0.9*T + GHSERMG# + 2600; 3000.0 N !
FUNCTION GHCPCU 298.15 0.2*T + GHSERCU# + 600; 3200.0 N !
FUNCTION GHCPMG 298.15 GHSERMG#; 3000.0 N !
FUNCTION GHSERCU 298.15 1.29223E-7*T**3 - 0.00265684*T**2 - 24.112392*T*LN(T)
   + 130.485235*T - 7770.458 + 52478*T**(-1); 1357.77 Y -31.38*T*LN(T) +
   183.803828*T - 13542.026 + 3.64167E+29*T**(-9); 3200.0 N !
FUNCTION GHSERMG 298.15 -1.393669E-6*T**3 + 0.0004858*T**2 -
   26.1849782*T*LN(T) + 143.675547*T - 8367.34 + 78950*T**(-1); 923.0 Y
   -34.3088*T*LN(T) + 204.716215*T - 14130.185 + 1.038192E+28*T**(-9); 3000.0
   N !
FUNCTION GHSERVA 1 0; 10000 N !
FUNCTION GLAVCU 298.15 3.87669E-7*T**3 - 0.00797052*T**2 - 72.337176*T*LN(T)
   + 391.455705*T - 8311.374 + 157434*T**(-1); 1357.77 Y -94.14*T*LN(T) +
   551.411484*T - 25626.078 + 1.092501E+30*T**(-9); 3200.0 N !
FUNCTION GLAVMG 298.15 -4.181007E-6*T**3 + 0.0014574*T**2 -
   78.5549346*T*LN(T) + 431.026641*T - 10102.02 + 236850*T**(-1); 923.0 Y
   -102.9264*T*LN(T) + 614.148645*T - 27390.555 + 3.11458E+28*T**(-9); 3000.0
   N !
FUNCTION GLIQCU 298.15 -5.8489E-21*T**7 - 9.511904*T + GHSERCU# + 12964.735;
   1357.77 Y -31.38*T*LN(T) + 173.881484*T - 46.545; 3200.0 N !
FUNCTION GLIQMG 298.15 -8.0176E-20*T**7 - 8.83693*T + GHSERMG# + 8202.243;
   923.0 Y -34.3088*T*LN(T) + 195.324057*T - 5439.869; 3000.0 N !
FUNCTION VV0000 1 -32429.6; 10000 N !
FUNCTION VV0001 1 -4.12896; 10000 N !
FUNCTION VV0002 1 8.2363; 10000 N !
FUNCTION VV0003 1 -14.0865; 10000 N !
FUNCTION VV0004 1 -11.2723; 10000 N !
FUNCTION VV0005 1 11.1114; 10000 N !
FUNCTION VV0006 1 -8.29125; 10000 N !
FUNCTION VV0007 1 -14.9845; 10000 N !
FUNCTION VV0008 1 -40470.2; 10000 N !
FUNCTION VV0009 1 104160.0; 10000 N !
FUNCTION VV0010 1 17766.4; 10000 N !
FUNCTION VV0011 1 150325.0; 10000 N !
FUNCTION VV0012 1 21243.0; 10000 N !
FUNCTION VV0013 1 214671.0; 10000 N !
FUNCTION VV0014 1 14321.1; 10000 N !
FUNCTION VV0015 1 -4923.18; 10000 N !
FUNCTION VV0016 1 -1962.8; 10000 N !
FUNCTION VV0017 1 -31626.6; 10000 N !

TYPE_DEFINITION % SEQ * !
DEFINE_SYSTEM_DEFAULT ELEMENT 2 !
DEFAULT_COMMAND DEFINE_SYSTEM_ELEMENT VA !

PHASE CUMG2 %  2 1 2 !
CONSTITUENT CUMG2 :CU:MG: !

PHASE FCC_A1 %  2 1 1 !
CONSTITUENT FCC_A1 :CU,MG:VA: !

PHASE HCP_A3 %  2 1 0.5 !
CONSTITUENT HCP_A3 :CU,MG:VA: !

PHASE LAVES_C15 %  2 2 1 !
CONSTITUENT LAVES_C15 :CU,MG:CU,MG: !

PHASE LIQUID %  1 1 !
CONSTITUENT LIQUID :COMPA,COMPB,COMPC: !



$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$
$                                     CU                                     $
$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$

PARAMETER G(FCC_A1,CU:VA;0) 1 GFCCCU#; 10000 N !
PARAMETER G(HCP_A3,CU:VA;0) 1 GHCPCU#; 10000 N !
PARAMETER G(LAVES_C15,CU:CU;0) 1 GLAVCU#; 10000 N !
PARAMETER G(LIQUID,COMPA;0) 1 GLIQCU#; 10000 N !


$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$
$                                     MG                                     $
$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$

PARAMETER G(FCC_A1,MG:VA;0) 1 GFCCMG#; 10000 N !
PARAMETER G(HCP_A3,MG:VA;0) 1 GHCPMG#; 10000 N !
PARAMETER G(LAVES_C15,MG:MG;0) 1 GLAVMG#; 10000 N !
PARAMETER G(LIQUID,COMPC;0) 1 GLIQMG#; 10000 N !


$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$
$                                   CU-MG                                    $
$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$

PARAMETER G(CUMG2,CU:MG;0) 1 GHSERCU# + 2*GHSERMG# + VV0000#; 10000 N !
PARAMETER L(FCC_A1,CU,MG:VA;0) 1 VV0003#; 10000 N !
PARAMETER L(FCC_A1,CU,MG:VA;1) 1 VV0002#; 10000 N !
PARAMETER L(FCC_A1,CU,MG:VA;2) 1 VV0001#; 10000 N !
PARAMETER L(HCP_A3,CU,MG:VA;0) 1 VV0007#; 10000 N !
PARAMETER L(HCP_A3,CU,MG:VA;1) 1 VV0006#; 10000 N !
PARAMETER L(HCP_A3,CU,MG:VA;2) 1 VV0005#; 10000 N !
PARAMETER L(HCP_A3,CU,MG:VA;3) 1 VV0004#; 10000 N !
PARAMETER G(LAVES_C15,CU:MG;0) 1 2*GHSERCU# + GHSERMG# + VV0008#; 10000 N !
PARAMETER G(LAVES_C15,MG:CU;0) 1 GHSERCU# + 2*GHSERMG# + VV0009#; 10000 N !
PARAMETER L(LAVES_C15,CU:CU,MG;0) 1 VV0010#; 10000 N !
PARAMETER L(LAVES_C15,CU,MG:CU;0) 1 VV0011#; 10000 N !
PARAMETER L(LAVES_C15,CU,MG:MG;0) 1 VV0012#; 10000 N !
PARAMETER L(LAVES_C15,MG:CU,MG;0) 1 VV0013#; 10000 N !
PARAMETER L(LIQUID,COMPA,COMPC;0) 1 VV0017#; 10000 N !
PARAMETER L(LIQUID,COMPA,COMPC;1) 1 VV0016#; 10000 N !
PARAMETER L(LIQUID,COMPA,COMPC;2) 1 VV0015#; 10000 N !
PARAMETER L(LIQUID,COMPA,COMPC;3) 1 VV0014#; 10000 N !

"""


CU_MG_EXP_ACTIVITY = yaml.load("""{
  "components": ["CU", "MG", "VA"],
  "phases": ["LIQUID"],
  "reference_state": {
    "phases": ["LIQUID"],
    "conditions": {
      "P": 101325,
      "T": 1200,
      "X_CU": 0.0
    }
  },
  "conditions": {
    "P": 101325,
    "T": 1200,
    "X_CU": [0.9, 0.8, 0.7, 0.6, 0.5, 0.4, 0.3, 0.2, 0.1, 0.0]
  },

  "output": "ACR_MG",
    "values":   [[[0.0057,0.0264,0.0825,0.1812,0.2645,0.4374,0.5852,0.7296,0.882,1.0]]],
  "reference": "garg1973thermodynamic",
  "comment": "Digitized Figure "
}
""", Loader=YAML_LOADER)


CU_MG_EQ_HMR_LIQUID = {
    "components": ["CU", "MG"],
    "phases": ["LIQUID"],
    "conditions": {"P": 101325, "T": [1400], "X_MG": [0.5]},
    "reference_states": {
        "CU": {"phase": "LIQUID"},
        "MG": {"phase": "LIQUID"}
    },
    "output": "HMR",
    "values": [[[0]]],
    "reference": "equilibrium thermochemical tests", "comment": "True values depend on parameters."
}


CU_MG_HM_MIX_CUMG2_ANTISITE = yaml.load("""{
  "components": ["CU", "MG", "VA"],
  "phases": ["CUMG2"],
  "solver": {
    "sublattice_site_ratios": [1, 2],
    "sublattice_configurations": [["CU", "MG"], ["MG", "CU"], ["MG", "MG"], ["CU", "CU"]],
    "mode": "manual"
  },
  "conditions": {
    "P": 101325,
    "T": [300, 400],
  },

  "output": "HM_MIX",
    "values":   [[[10, 11, 12, 13], [100, 101, 102, 103]]],
  "reference": "FAKE DATA",
  "comment": "FAKE DATA"
}
""", Loader=YAML_LOADER)


CU_MG_HM_MIX_CUMG2_ALL_INVALID = yaml.load("""{
  "components": ["CU", "MG", "VA"],
  "phases": ["CUMG2"],
  "solver": {
    "sublattice_site_ratios": [1, 2],
    "sublattice_configurations": [["MG", "CU"], ["MG", "MG"], ["CU", "CU"]],
    "mode": "manual"
  },
  "conditions": {
    "P": 101325,
    "T": [300, 400],
  },

  "output": "HM_MIX",
    "values":   [[[11, 12, 13], [101, 102, 103]]],
  "reference": "FAKE DATA",
  "comment": "FAKE DATA"
}
""", Loader=YAML_LOADER)


CU_MG_HM_MIX_T_CUMG2 = yaml.load("""{
  "components": ["CU", "MG", "VA"],
  "phases": ["CUMG2"],
  "solver": {
    "sublattice_site_ratios": [1, 2],
    "sublattice_configurations": [["CU", "MG"]],
    "mode": "manual"
  },
  "conditions": {
    "P": 101325,
    "T": [300, 400],
  },

  "output": "HM_MIX",
    "values":   [[[10], [100]]],
  "reference": "FAKE DATA",
  "comment": "FAKE DATA"
}
""", Loader=YAML_LOADER)


CU_MG_SM_MIX_T_X_FCC_A1 = yaml.load("""{
  "components": ["CU", "MG", "VA"],
  "phases": ["FCC_A1"],
  "solver": {
    "sublattice_site_ratios": [1, 1],
    "sublattice_occupancies": [
    [[0.5, 0.5], 1],
    [[0.1, 0.9], 1]
    ],
    "sublattice_configurations": [
    [["CU", "MG"], "VA"],
    [["CU", "MG"], "VA"]
    ],
    "mode": "manual"
  },
  "conditions": {
    "P": 101325,
    "T": [300, 400],
  },

  "output": "SM_MIX",
    "values":   [[[10, 50], [100, 500]]],
  "reference": "FAKE DATA",
  "comment": "FAKE DATA",
  "excluded_model_contributions": ["idmix"]
}
""", Loader=YAML_LOADER)


CU_MG_CPM_MIX_X_HCP_A3 = yaml.load("""{
  "components": ["CU", "MG", "VA"],
  "phases": ["HCP_A3"],
  "solver": {
    "sublattice_site_ratios": [1, 1],
    "sublattice_occupancies": [
    [[0.5, 0.5], 1],
    [[0.1, 0.9], 1]
    ],
    "sublattice_configurations": [
    [["CU", "MG"], "VA"],
    [["CU", "MG"], "VA"]
    ],
    "mode": "manual"
  },
  "conditions": {
    "P": 101325,
    "T": 300,
  },

  "output": "CPM_MIX",
    "values":   [[[10, 15]]],
  "reference": "FAKE DATA",
  "comment": "FAKE DATA"
}
""", Loader=YAML_LOADER)


CU_MG_HM_MIX_SINGLE_FCC_A1 = yaml.load("""
{
    "components": ["CU", "MG"],
    "phases": ["FCC_A1"],
    "solver": {
        "sublattice_site_ratios": [1],
        "sublattice_occupancies": [[[0.5, 0.5], 1]],
        "sublattice_configurations": [[["CU", "MG"], "VA"]],
        "mode": "manual"
    },
    "conditions": {
        "P": 101325,
        "T": 300.0
    },
    "output": "HM_MIX",
    "values": [[[-1000]]]
}
""", Loader=YAML_LOADER)


CU_MG_DATASET_ZPF_ZERO_ERROR = yaml.load("""{
  "components": ["CU", "MG", "VA"],
  "phases": ["FCC_A1", "LAVES_C15"],
  "conditions": {
    "P": 101325,
    "T": 600
  },
  "output": "ZPF",
    "values":   [
    [["FCC_A1", ["CU"], [0.99980142076590905]], ["LAVES_C15", ["CU"], [0.66713918519314885]]]
    ],
  "reference": "testing",
  "comment": "From a calculation of: `equilibrium(Database(CU_MG_TDB), ['CU','MG','VA'], ['FCC_A1', 'LAVES_C15'], {v.P: 101325, v.X('MG'): 0.1, v.T: 600})`"
}
""", Loader=YAML_LOADER)


CU_MG_DATASET_ZPF_STOICH_COMPOUND = yaml.load("""{
  "components": ["CU", "MG"],
  "phases": ["LIQUID", "CUMG2"],
  "conditions": {
    "P": 101325,
    "T": 400
  },
  "output": "ZPF",
    "values":   [
    [["CUMG2", ["CU"], [0.3333333333]], ["LIQUID", ["CU"], [null]]]
    ],
  "reference": "testing",
  "comment": "A stoichiometric compound is stable and the composition is approximate."
}
""", Loader=YAML_LOADER)


CU_MG_DATASET_ZPF_NAN_EQUILIBRIUM = yaml.load("""{
  "components": ["CU", "MG", "VA"],
  "phases": ["FCC_A1", "LIQUID"],
  "conditions": {
    "P": 101325,
    "T": 2000
  },
  "output": "ZPF",
    "values":   [
    [["FCC_A1", ["CU"], [0.5]], ["LIQUID", ["CU"], [null]]]
    ],
  "reference": "testing",
  "comment": "This dataset actually works, but this is just a dummy for the test."
}
""", Loader=YAML_LOADER)


CU_MG_DATASET_ZPF_WORKING = yaml.load("""{
    "components": ["CU", "MG", "VA"],
    "phases": ["LIQUID", "FCC_A1"],
    "conditions": {
      "P": 101325,
      "T": [1337.97, 1262.238]
    },
    "broadcast_conditions": false,
    "output": "ZPF",
    "values":   [
        [["LIQUID", ["MG"], [0.0246992]], ["FCC_A1", ["MG"],  [null]]],
        [["LIQUID", ["MG"], [0.0712664]], ["FCC_A1", ["MG"],  [null]]]
    ],
    "reference": "Sahmen1908"
}
""", Loader=YAML_LOADER)


A_B_DATASET_BINARY_PHASE_EQUILIBRIA = yaml.load("""{
  "components": ["A", "B"],
  "phases": ["PHASE_1", "PHASE_2", "PHASE_3"],
  "conditions": {
    "P": 101325,
    "T": [100, 200, 300]
  },
  "output": "ZPF",
    "values":   [
    [["PHASE_1", ["B"], [0.25]], ["PHASE_2", ["B"], [null]]],
    [["PHASE_1", ["B"], [0.25]], ["PHASE_2", ["B"], [0.5]]],
    [["PHASE_1", ["B"], [0.25]], ["PHASE_2", ["B"], [0.5]], ["PHASE_3", ["B"], [0.75]]]
   ],
  "reference": "testing",
  "comment": "Examples for 1. one side of tieline, 2. a full tieline, 3. a 3 phase equilibria. For MPL visual checking that plot is correct"
}
""", Loader=YAML_LOADER)


A_B_DATASET_ALPHA = yaml.load("""{
  "components": ["A", "B"],
  "phases": ["ALPHA"],
  "conditions": {
    "P": 101325,
    "T": [300.0]
  },
  "output": "ZPF",
    "values":   [
    [["ALPHA", ["B"], [0.5]]]
   ],
  "reference": "testing",
  "comment": "Single phase case"
}
""", Loader=YAML_LOADER)


A_B_C_DATASET_TERNARY_PHASE_EQUILIBRIA = yaml.load("""{
  "components": ["A", "B", "C"],
  "phases": ["PHASE_1", "PHASE_2", "PHASE_3"],
  "conditions": {
    "P": 101325,
    "T": [300, 300, 300]
  },
  "output": "ZPF",
    "values":   [
    [["PHASE_1", ["B", "C"], [0.1, 0.1]], ["PHASE_2", ["B", "C"], [null, null]]],
    [["PHASE_1", ["B", "C"], [0.2, 0.5]], ["PHASE_2", ["B", "C"], [0.3, 0.6]]],
    [["PHASE_1", ["B", "C"], [0.2, 0.2]], ["PHASE_1", ["B", "C"], [0.3, 0.3]], ["PHASE_2", ["B", "C"], [0.5, 0.1]]],
   ],
  "reference": "testing",
  "comment": "Examples for 1. one side of tieline, 2. a full tieline, 3. a 3 phase equilibria. For MPL visual checking that plot is correct"
}
""", Loader=YAML_LOADER)


CU_MG_DATASET_THERMOCHEMICAL_STRING_VALUES = yaml.load("""{
  "components": ["CU", "MG", "VA"],
  "phases": ["CUMG2"],
  "solver": {
    "sublattice_site_ratios": ["1", "2"],
    "sublattice_configurations": [["CU", "MG"]],
    "mode": "manual"
  },
  "conditions": {
    "P": "101325",
    "T": ["300", "400"],
  },

  "output": "HM_MIX",
    "values":   [[["10"], ["100"]]],
  "reference": "FAKE DATA",
  "comment": "FAKE DATA"
}
""", Loader=YAML_LOADER)


CU_MG_DATASET_ZPF_STRING_VALUES = yaml.load("""{
    "components": ["CU", "MG", "VA"],
    "phases": ["LIQUID", "FCC_A1"],
    "conditions": {
      "P": "101325",
      "T": ["1337.97", "1262.238"]
    },
    "broadcast_conditions": false,
    "output": "ZPF",
    "values":   [
        [["LIQUID", ["MG"], ["0.0246992"]], ["FCC_A1", ["MG"],  [null]]],
        [["LIQUID", ["MG"], ["0.0712664"]], ["FCC_A1", ["MG"],  [null]]]
    ],
    "reference": "Sahmen1908"
}
""", Loader=YAML_LOADER)


AL_CO_CR_A2_PHASE_MODELS = {
  "components": ["AL", "CO", "CR"],
  "phases": {
         "BCC_A2": {
            "sublattice_model": [["AL", "CO", "CR"]],
            "sublattice_site_ratios": [1]
         }
    }
}

AL_CO_CR_B2_PHASE_MODELS = {
  "components": ["AL", "CO", "CR"],
  "phases": {
         "BCC_B2": {
            "sublattice_model": [["AL", "CO", "CR"], ["AL", "CO", "CR"]],
            "sublattice_site_ratios": [0.5, 0.5]
         }
    }
}


AL_CO_CR_A2_TERNARY_SYMMETRIC_DATASET = {
    "components": ["AL", "CO", "CR"],
    "phases": ["BCC_A2"],
    "solver": {
        "mode": "manual",
        "sublattice_site_ratios": [1],
        "sublattice_occupancies": [[[0.333, 0.333, 0.334]]],
        "sublattice_configurations": [[["AL", "CO", "CR"]]]
    },
    "conditions": {
        "P": 101325,
        "T": 298.15
        },
    "output": "HM_MIX",
    "values":   [[[-7860.0]]],
    "reference": "liu2015first",
    "comment": "Ternary disordered BCC from Table 4"
}


AL_CO_A2_BINARY_SYMMETRIC_DATASET = {
    "components": ["AL", "CO"],
    "phases": ["BCC_A2"],
    "solver": {
        "mode": "manual",
        "sublattice_site_ratios": [1],
        "sublattice_occupancies": [[[0.5, 0.5]]],
        "sublattice_configurations": [[["AL", "CO"]]]
    },
    "conditions": {
        "P": 101325,
        "T": 298.15
    },
    "output": "HM_MIX",
    "values":   [[[-1000.0]]],
    "reference": "liu2015first",
    "comment": "Ternary disordered BCC from Table 4"
}


AL_CO_CR_BCC_A2_TERNARY_NON_SYMMETRIC_DATASET = {
    "components": ["AL", "CO", "CR"],
    "phases": ["BCC_A2"],
    "solver": {
        "mode": "manual",
        "sublattice_site_ratios": [1, 1],
        "sublattice_occupancies": [
            [[0.25, 0.25, 0.5]],
            [[0.25, 0.5, 0.25]],
            [[0.5, 0.25, 0.25]]
        ],
        "sublattice_configurations": [
            [["AL", "CO", "CR"]],
            [["AL", "CO", "CR"]],
            [["AL", "CO", "CR"]]
        ]
    },
    "conditions": {
        "P": 101325,
        "T": 298.15
    },
    "output": "HM_MIX",
    "values":   [[[-70.3125, -62.5, -54.6875]]],
    "reference": "",
    "comment": ""
}

AL_CO_CR_BCC_B2_TERNARY_NON_SYMMETRIC_DATASET = {
    "components": ["AL", "CO", "CR"],
    "phases": ["BCC_B2"],
    "solver": {
        "mode": "manual",
        "sublattice_site_ratios": [0.5, 0.5],
        "sublattice_occupancies": [

            [[0.25, 0.25, 0.5], 1],
            [[0.25, 0.5, 0.25], 1],
            [[0.5, 0.25, 0.25], 1]
        ],
        "sublattice_configurations": [
            [["AL", "CO", "CR"], "AL"],
            [["AL", "CO", "CR"], "AL"],
            [["AL", "CO", "CR"], "AL"]
        ]
    },
    "conditions": {
        "P": 101325,
        "T": 298.15
    },
    "output": "HM_MIX",
    "values":   [[[-140.625, -125.0, -109.375]]],
    "reference": "",
    "comment": ""
}

CU_ZN_LIQUID_PHASE_MODEL = {
  "components": ["CU", "ZN"], "refdata": "SGTE91",
  "phases": {"LIQUID" : {
	"sublattice_model": [["CU", "ZN"]],
	"sublattice_site_ratios": [1]}}
}

CU_ZN_CPM_MIX_EXPR_TO_FLOAT = {
"components": ["CU", "ZN"], "phases": ["LIQUID"],
"solver": {"mode": "manual", "sublattice_site_ratios": [1],
           "sublattice_configurations": [[["CU", "ZN"]],[["CU", "ZN"]],[["CU", "ZN"]]],
"sublattice_occupancies": [[[0.5, 0.5]], [[0.1, 0.9]], [[0.8, 0.2]]]},
"conditions": {"P": 101325, "T": 300},
"output": "CPM_MIX",
"values": [[[11.1425, -5.0, 5.0]]]
}

CU_ZN_SM_MIX_EXPR_TO_FLOAT = {
"components": ["CU", "ZN"],"phases": ["LIQUID"],
"solver": {"mode": "manual", "sublattice_site_ratios": [1],
           "sublattice_configurations": [[["CU", "ZN"]]],
"sublattice_occupancies": [[[0.25, 0.75]]]},
"conditions": {"P": 101325, "T": 600},
"output": "SM_MIX",
"values": [[[-9.952211364]]],
"excluded_model_contributions": ["idmix"]
}

###############################################################################
# CR-FE
###############################################################################

CR_FE_PHASE_MODELS = {
    "components": ["CR", "FE", "VA"],
    "phases": {
           "BCC_A2": {
              "sublattice_model": [["CR", "FE"], ["VA"]],
              "sublattice_site_ratios": [1, 3]
           }
      }
  }

CR_FE_HM_MIX_EXCLUDED_MAG = {
"components": ["CR", "FE", "VA"],"phases": ["BCC_A2"],
"solver": {"mode": "manual", "sublattice_site_ratios": [1, 3],
           "sublattice_configurations": [[["CR", "FE"], "VA"]],
"sublattice_occupancies": [[[0.5, 0.5], 1.0]]},
"conditions": {"P": 101325, "T": 300},
"output": "HM_MIX",
"values": [[[10000]]],
"excluded_model_contributions": ["mag"]
}

CR_FE_HM_MIX_WITH_MAG = {
"components": ["CR", "FE", "VA"],"phases": ["BCC_A2"],
"solver": {"mode": "manual", "sublattice_site_ratios": [1, 3],
           "sublattice_configurations": [[["CR", "FE"], "VA"]],
"sublattice_occupancies": [[[0.5, 0.5], 1.0]]},
"conditions": {"P": 101325, "T": 300},
"output": "HM_MIX",
"values": [[[7128.41104097]]]
}

CR_FE_INITIAL_TDB_CONTRIBUTIONS = """$ Cr-Fe database with only magnetic parts
$ As assessed by Xiong doi:10.1016/j.calphad.2011.05.002
 ELEMENT VA   VACUUM           0.0000E+00  0.0000E+00  0.0000E+00!
 ELEMENT FE   BCC_A2           5.5847E+01  4.4890E+03  2.7280E+01!
 ELEMENT CR   BCC_A2           5.1996E+01  4.0500E+03  2.3560E+01!
 TYPE_DEFINITION % SEQ * !
$             **********   FCC_A1   *********
 TYPE_DEFINITION G GES AM-PH FCC_A1 MAG -3 0.25 !
 PHASE FCC_A1  %G  2 1   1 !
    CONSTITUENT FCC_A1  :CR,FE : VA :  !
   PARAMETER TC(FCC_A1,FE:VA;0)  2.98150E+02  -201;    6000 N !
   PARAMETER BMAGN(FCC_A1,FE:VA;0)  2.98150E+02  -2.1; 6000 N !
   PARAMETER TC(FCC_A1,CR:VA;0)  2.98150E+02  -1109;   6000 N !
   PARAMETER BMAGN(FCC_A1,CR:VA;0)  2.98150E+02  -2.46; 6000 N !

$             *******   BCC_A2   ************
 TYPE_DEFINITION C GES AM-PH BCC MAG -1 0.37 !
 PHASE BCC_A2  %C  2 1   3 !
    CONSTITUENT BCC_A2  :CR,FE : VA :  !
   PARAMETER TC(BCC_A2,FE:VA;0)  2.98150E+02  1043; 6000 N !
   PARAMETER BMAGN(BCC_A2,FE:VA;0)  2.98150E+02  2.22; 6000 N !
   PARAMETER TC(BCC_A2,CR:VA;0)  2.98150E+02  -311.5; 6000 N !
   PARAMETER BMAGN(BCC_A2,CR:VA;0)  2.98150E+02  -.008; 6000 N !
   PARAMETER BMAGN(BCC_A2,CR,FE:VA;0)  2.98150E+02  -.45; 6000 N !
   PARAMETER TC(BCC_A2,CR,FE:VA;0)  2.98150E+02   865.5; 6000 N !
   PARAMETER TC(BCC_A2,CR,FE:VA;1)  2.98150E+02   -567.2; 6000 N !
"""


CR_NI_LIQUID_DATA = {
    "components": ["CR", "NI"],
    "phases": ["LIQUID"],
    "solver": {
        "mode": "manual",
        "sublattice_site_ratios": [1],
        "sublattice_configurations": [[["CR", "NI"]], [["CR", "NI"]], [["CR", "NI"]], [["CR", "NI"]]],
        "sublattice_occupancies": [[[0.023, 0.977]], [[0.048, 0.952]], [[0.075, 0.925]], [[0.073, 0.927]]]
    },
    "conditions": {"P": 101325, "T": 1729},
    "output": "HM_MIX",
    "values": [[[-300, -700, -1200, -1200]]],
    "reference": "non-equilibrium thermochemical tests", "comment": ""
}


CR_NI_ZPF_DATA = {
    "components": ["CR", "NI", "VA"],
    "phases": ["BCC_A2", "FCC_A1"],
    "broadcast_conditions": False,
    "conditions": {
        "T": [1073, 1173, 1273, 1373, 1548],
        "P": [101325.0]
    },
    "output": "ZPF",
    "values": [
        [["FCC_A1", ["CR"], [0.3866]], ["BCC_A2", ["NI"], [None]]],
        [["FCC_A1", ["CR"], [0.3975]], ["BCC_A2", ["NI"], [None]]],
        [["FCC_A1", ["CR"], [0.4480]], ["BCC_A2", ["NI"], [None]]],
        [["FCC_A1", ["CR"], [0.4643]], ["BCC_A2", ["NI"], [None]]],
        [["FCC_A1", ["CR"], [0.4984]], ["BCC_A2", ["NI"], [None]]]
    ],
    "reference": "zpf test", "comment": ""
}


CR_NI_ACTIVITY = {
    "components": ["CR", "NI", "VA"],
    "phases": ["LIQUID"],
    "reference_state": {
        "phases": ["LIQUID"],
        "conditions": {"P": 101325, "T": 1200, "X_NI": 1.0}
    },
    "conditions": {"P": 101325, "T": 1200, "X_NI": [0.9]},
    "output": "ACR_NI",
    "values": [[[0.9]]],
    "reference": "activity test", "comment": "Example, nearly ideal"
}


CR_NI_LIQUID_EQ_TC_DATA = {
    "components": ["CR", "NI"],
    "phases": ["FCC_A1"],
    "conditions": {"P": 101325, "T": [500, 600, 700], "X_NI": 0.95},
    "output": "TC",
    "values": [[[0.0], [374.6625], [374.6625]]],
    "reference": "equilibrium thermochemical tests", "comment": "Data checked by pycalphad. Values should be temperature independent and both temperature calulcations should give the 374.6625 value. Note, there's a low temperature miscibility gap (below 453 K)"
}


CR_FE_NI_TDB = """
Element VA                VACUUM         0         0         0  !
ELEMENT CR                BCC_A2    51.996      4050    23.560  !
ELEMENT FE                BCC_A2    55.847      4489    27.28   !
Element NI                FCC_A1    58.69       4787    29.7955 !

FUNCTION GLIQCR  300 +15483.015+146.059775*T-26.908*T*LN(T)
   +.00189435*T**2-1.47721E-06*T**3+139250*T**(-1)+2.37615E-21*T**7;  2180 Y
   -16459.984+335.616316*T-50*T*LN(T);                                6000 N !
FUNCTION GBCCCR  300 -8856.94+157.48*T
 -26.908*T*LN(T)+.00189435*T**2-1.47721E-06*T**3+139250*T**(-1);      2180 Y
  -34869.344+344.18*T-50*T*LN(T)-2.885261E+32*T**(-9);                6000 N !
FUNCTION GFCCCR  300 -1572.94+157.643*T
 -26.908*T*LN(T)+.00189435*T**2-1.47721E-06*T**3+139250*T**(-1);      2180 Y
  -27585.344+344.343*T-50*T*LN(T)-2.885261E+32*T**(-9);               6000 N !
FUNCTION GBCCFE  300  +1225.7+124.134*T-23.5143*T*LN(T)
     -.00439752*T**2-5.8927E-08*T**3+77359*T**(-1);                    1811 Y
      -25383.581+299.31255*T-46*T*LN(T)+2.29603E+31*T**(-9);           6000 N !
FUNCTION GFCCFE 300 -1462.4+8.282*T-1.15*T*LN(T)+6.4E-4*T**2+GBCCFE;   1811 Y
      -1713.815+0.94001*T+4.9251E+30*T**(-9)+GBCCFE;                   6000 N !
FUNCTION GLIQFE  300  +13265.87+117.57557*T-23.5143*T*LN(T)
      -0.00439752*T**2-5.8927E-08*T**3+77359*T**(-1)-3.67516E-21*T**7; 1811 Y
      -10838.83+291.302*T-46*T*LN(T);                                  6000 N !
FUNCTION GFCCNI  300 -5179.159+117.854*T
      -22.096*T*ln(T)-0.0048407*T**2;                                 1728 Y
      -27840.655+279.135*T-43.1*T*ln(T)+1.12754e+031*T**(-9);         3000 N !
FUNCTION GLIQNI  300  11235.527+108.457*T-22.096*T*ln(T)
      -0.0048407*T**2-3.82318e-021*T**7;                              1728 Y
      -9549.775+268.598*T-43.1*T*ln(T);                               3000 N !
FUNCTION GBCCNI     300  +8715.084-3.556*T+GFCCNI;                    6000 N !

FUNCTION ZERO       300  +0;                                          6000 N !
FUNCTION UN_ASS     300  +0;                                          6000 N !


TYPE_DEFINITION % SEQ * !
DEFINE_SYSTEM_DEFAULT ELEMENT 3 !

TYPE_DEFINITION ' GES A_P_D BCC_A2 MAGNETIC  -1    0.4  !
Type_Definition ( GES A_P_D FCC_A1 Magnetic  -3    0.28 !

 Phase LIQUID % 1 1 !
 Constituent LIQUID : CR,FE,NI : !

 PARAMETER G(LIQUID,CR;0)     300  +GLIQCR;               6000 N !
 PARAMETER G(LIQUID,FE;0)     300  +GLIQFE;               6000 N !
 PARAMETER G(LIQUID,NI;0)     300  +GLIQNI;               6000 N !

 PARAMETER G(LIQUID,CR,FE;0)  300  -17737+7.996546*T;     6000 N !
 PARAMETER G(LIQUID,CR,FE;1)  300  -1331;                 6000 N !
 PARAMETER G(LIQUID,CR,NI;0)  300  +318-7.3318*T;         6000 N !
 PARAMETER G(LIQUID,CR,NI;1)  300  +16941-6.3696*T;       6000 N !
 PARAMETER G(LIQUID,FE,NI;0)  300  -16911+5.1622*T;       6000 N !
 PARAMETER G(LIQUID,FE,NI;1)  300  +10180-4.146656*T;     6000 N !

 PARAMETER G(LIQUID,CR,FE,NI;0) 300 +130000-50*T;         6000 N !
 PARAMETER G(LIQUID,CR,FE,NI;1) 300 +80000-50*T;          6000 N !
 PARAMETER G(LIQUID,CR,FE,NI;2) 300 +60000-50*T;          6000 N !


PHASE BCC_A2  %'  2 1   3 !
CONSTITUENT BCC_A2  : CR,FE,NI : VA :  !

 PARAMETER G(BCC_A2,CR:VA;0)      300 +GBCCCR;             6000 N !
 PARAMETER G(BCC_A2,FE:VA;0)      300 +GBCCFE;             6000 N !
 PARAMETER G(BCC_A2,NI:VA;0)      300 +GBCCNI;             3000 N !
 PARAMETER TC(BCC_A2,CR:VA;0)     300 -311.5;              6000 N !
 PARAMETER TC(BCC_A2,FE:VA;0)     300 +1043;               6000 N !
 PARAMETER TC(BCC_A2,NI:VA;0)     300 +575;                6000 N !
 PARAMETER BMAGN(BCC_A2,CR:VA;0)  300 -0.008;              6000 N !
 PARAMETER BMAGN(BCC_A2,FE:VA;0)  300 +2.22;               6000 N !
 PARAMETER BMAGN(BCC_A2,NI:VA;0)  300 +0.85;               6000 N !

 PARAMETER TC(BCC_A2,CR,FE:VA;0)  300 +1650;               6000 N !
 PARAMETER TC(BCC_A2,CR,FE:VA;1)  300 +550;                6000 N !
 PARAMETER TC(BCC_A2,CR,NI:VA;0)  300 +2373;               6000 N !
 PARAMETER TC(BCC_A2,CR,NI:VA;1)  300 +617;                6000 N !
 PARAMETER TC(BCC_A2,FE,NI:VA;0)    300 +ZERO;             6000 N !
 PARAMETER BMAGN(BCC_A2,CR,FE:VA;0) 300 -0.85;             6000 N !
 PARAMETER BMAGN(BCC_A2,CR,NI:VA;0) 300 +4;                6000 N !
 PARAMETER BMAGN(BCC_A2,FE,NI:VA;0) 300 +ZERO;             6000 N !

 PARAMETER G(BCC_A2,CR,FE:VA;0)   300 +20500-9.68*T;       6000 N !
 PARAMETER G(BCC_A2,CR,NI:VA;0)   300 +17170-11.8199*T;    6000 N !
 PARAMETER G(BCC_A2,CR,NI:VA;1)   300 +34418-11.8577*T;    6000 N !
 PARAMETER G(BCC_A2,FE,NI:VA;0)   300 -956.63-1.28726*T;   6000 N !
 PARAMETER G(BCC_A2,FE,NI:VA;1)   300 +1789.03-1.92912*T;  6000 N !

 PARAMETER G(BCC_A2,CR,FE,NI:VA;0) 300 +6000.+10*T;        6000 N !
 PARAMETER G(BCC_A2,CR,FE,NI:VA;1) 300 -18500+10*T;        6000 N !
 PARAMETER G(BCC_A2,CR,FE,NI:VA;2) 300 -27000+10*T;        6000 N !

Phase FCC_A1 %( 2  1  1  !
Constituent FCC_A1 : CR,FE,NI : VA : !

 PARAMETER G(FCC_A1,CR:VA;0)      300  +GFCCCR;             6000 N !
 PARAMETER G(FCC_A1,FE:VA;0)      300  +GFCCFE;             6000 N !
 PARAMETER G(FCC_A1,NI:VA;0)      300  +GFCCNI;             3000 N !
 PARAMETER TC(FCC_A1,CR:VA;0)     300  -1109;               6000 N !
 PARAMETER TC(FCC_A1,FE:VA;0)     300  -201;                6000 N !
 PARAMETER TC(FCC_A1,NI:VA;0)     300  +633;                6000 N !
 PARAMETER BMAGN(FCC_A1,CR:VA;0)  300  -2.46;               6000 N !
 PARAMETER BMAGN(FCC_A1,FE:VA;0)  300  -2.1;                6000 N !
 PARAMETER BMAGN(FCC_A1,NI:VA;0)  300  +0.52;               6000 N !

 PARAMETER TC(FCC_A1,CR,FE:VA;0)    300  +UN_ASS;           6000 N !
 PARAMETER TC(FCC_A1,CR,NI:VA;0)    300  -3605;             6000 N !
 PARAMETER TC(FCC_A1,FE,NI:VA;0)    300  +2133;             6000 N !
 PARAMETER TC(FCC_A1,FE,NI:VA;1)    300  -682;              6000 N !
 PARAMETER BMAGN(FCC_A1,CR,FE:VA;0) 300  +UN_ASS;           6000 N !
 PARAMETER BMAGN(FCC_A1,CR,NI:VA;0) 300  -1.91;             6000 N !
 PARAMETER BMAGN(FCC_A1,FE,NI:VA;0) 300  +9.55;             6000 N !
 PARAMETER BMAGN(FCC_A1,FE,NI:VA;1) 300  +7.23;             6000 N !
 PARAMETER BMAGN(FCC_A1,FE,NI:VA;2) 300  +5.93;             6000 N !
 PARAMETER BMAGN(FCC_A1,FE,NI:VA;3) 300  +6.18;             6000 N !

 PARAMETER G(FCC_A1,CR,FE:VA;0)  300 +10833-7.477*T;        6000 N !
 PARAMETER G(FCC_A1,CR,FE:VA;1)  300 +1410;                 6000 N !
 PARAMETER G(FCC_A1,CR,NI:VA;0)  300 +8030-12.8801*T;       6000 N !
 PARAMETER G(FCC_A1,CR,NI:VA;1)  300 +33080-16.0362*T;      6000 N !
 PARAMETER G(FCC_A1,FE,NI:VA;0)  300 -12054.355+3.27413*T;  6000 N !
 PARAMETER G(FCC_A1,FE,NI:VA;1)  300 +11082.1315-4.4507*T;  6000 N !
 PARAMETER G(FCC_A1,FE,NI:VA;2)  300 -725.805174;           6000 N !

 PARAMETER G(FCC_A1,CR,FE,NI:VA;0) 300 +10000+10*T;         6000 N !
 PARAMETER G(FCC_A1,CR,FE,NI:VA;1) 300 -6500;               6000 N !
 PARAMETER G(FCC_A1,CR,FE,NI:VA;2) 300 +48000;              6000 N !

$ Designed to only stabilize in the ternary Cr-Fe-Ni
Phase FEONLY % 2  1  1  !
Constituent FEONLY : FE : VA : !

 PARAMETER G(FEONLY,FE:VA;0) 300  -100000000; 6000 N !


"""

CR_NI_TDB = """
Element VA                VACUUM         0         0         0  !
ELEMENT CR                BCC_A2    51.996      4050    23.560  !
Element NI                FCC_A1    58.69       4787    29.7955 !

FUNCTION GLIQCR  300 +15483.015+146.059775*T-26.908*T*LN(T)
   +.00189435*T**2-1.47721E-06*T**3+139250*T**(-1)+2.37615E-21*T**7;  2180 Y
   -16459.984+335.616316*T-50*T*LN(T);                                6000 N !
FUNCTION GBCCCR  300 -8856.94+157.48*T
 -26.908*T*LN(T)+.00189435*T**2-1.47721E-06*T**3+139250*T**(-1);      2180 Y
  -34869.344+344.18*T-50*T*LN(T)-2.885261E+32*T**(-9);                6000 N !
FUNCTION GFCCCR  300 -1572.94+157.643*T
 -26.908*T*LN(T)+.00189435*T**2-1.47721E-06*T**3+139250*T**(-1);      2180 Y
  -27585.344+344.343*T-50*T*LN(T)-2.885261E+32*T**(-9);               6000 N !
FUNCTION GFCCNI  300 -5179.159+117.854*T
      -22.096*T*ln(T)-0.0048407*T**2;                                 1728 Y
      -27840.655+279.135*T-43.1*T*ln(T)+1.12754e+031*T**(-9);         3000 N !
FUNCTION GLIQNI  300  11235.527+108.457*T-22.096*T*ln(T)
      -0.0048407*T**2-3.82318e-021*T**7;                              1728 Y
      -9549.775+268.598*T-43.1*T*ln(T);                               3000 N !
FUNCTION GBCCNI     300  +8715.084-3.556*T+GFCCNI;                    6000 N !

FUNCTION ZERO       300  +0;                                          6000 N !
FUNCTION UN_ASS     300  +0;                                          6000 N !


TYPE_DEFINITION % SEQ * !
DEFINE_SYSTEM_DEFAULT ELEMENT 2 !

TYPE_DEFINITION ' GES A_P_D BCC_A2 MAGNETIC  -1    0.4  !
Type_Definition ( GES A_P_D FCC_A1 Magnetic  -3    0.28 !

 Phase LIQUID % 1 1 !
 Constituent LIQUID : CR,NI : !

 PARAMETER G(LIQUID,CR;0)     300  +GLIQCR;               6000 N !
 PARAMETER G(LIQUID,NI;0)     300  +GLIQNI;               6000 N !

 PARAMETER G(LIQUID,CR,NI;0)  300  +318-7.3318*T;         6000 N !
 PARAMETER G(LIQUID,CR,NI;1)  300  +16941-6.3696*T;       6000 N !

PHASE BCC_A2  %'  2 1   3 !
CONSTITUENT BCC_A2  : CR,NI : VA :  !

 PARAMETER G(BCC_A2,CR:VA;0)      300 +GBCCCR;             6000 N !
 PARAMETER G(BCC_A2,NI:VA;0)      300 +GBCCNI;             3000 N !
 PARAMETER TC(BCC_A2,CR:VA;0)     300 -311.5;              6000 N !
 PARAMETER TC(BCC_A2,NI:VA;0)     300 +575;                6000 N !
 PARAMETER BMAGN(BCC_A2,CR:VA;0)  300 -0.008;              6000 N !
 PARAMETER BMAGN(BCC_A2,NI:VA;0)  300 +0.85;               6000 N !

 PARAMETER TC(BCC_A2,CR,NI:VA;0)  300 +2373;               6000 N !
 PARAMETER TC(BCC_A2,CR,NI:VA;1)  300 +617;                6000 N !
 PARAMETER BMAGN(BCC_A2,CR,NI:VA;0) 300 +4;                6000 N !

 PARAMETER G(BCC_A2,CR,NI:VA;0)   300 +17170-11.8199*T;    6000 N !
 PARAMETER G(BCC_A2,CR,NI:VA;1)   300 +34418-11.8577*T;    6000 N !

Phase FCC_A1 %( 2  1  1  !
Constituent FCC_A1 : CR,NI : VA : !

 PARAMETER G(FCC_A1,CR:VA;0)      300  +GFCCCR;             6000 N !
 PARAMETER G(FCC_A1,NI:VA;0)      300  +GFCCNI;             3000 N !
 PARAMETER TC(FCC_A1,CR:VA;0)     300  -1109;               6000 N !
 PARAMETER TC(FCC_A1,NI:VA;0)     300  +633;                6000 N !
 PARAMETER BMAGN(FCC_A1,CR:VA;0)  300  -2.46;               6000 N !
 PARAMETER BMAGN(FCC_A1,NI:VA;0)  300  +0.52;               6000 N !

 PARAMETER TC(FCC_A1,CR,NI:VA;0)    300  -3605;             6000 N !
 PARAMETER BMAGN(FCC_A1,CR,NI:VA;0) 300  -1.91;             6000 N !

 PARAMETER G(FCC_A1,CR,NI:VA;0)  300 +8030-12.8801*T;       6000 N !
 PARAMETER G(FCC_A1,CR,NI:VA;1)  300 +33080-16.0362*T;      6000 N !

"""

LI_SN_TDB = """$ Li-Sn
$--------1---------2---------3---------4---------5---------6---------7---------8
$
$ TDB-file for the thermodynamic assessment of the Li-Sn system
$
$-----------------------------------------------------------------------------
$ 2015.1.15
$
$ TDB file created by T.Abe and S.Fujita
$
$ Thermodynamics Modeling Group, National Institute for
$ Materials Science. 1-2-1 Sengen, Tsukuba, Ibaraki 305-0047, Japan
$ e-mail: abe.taichi (at) nims.go.jp
$ Copyright (C) NIMS 2015
$
$ ------------------------------------------------------------------------------
$ PARAMETERS ARE TAKEN FROM
$
$ Thermodynamic assessment and experimental investigation of the Li-Sn system.
$ D. Li, S. Furtauer, H. Flandorfer, D.M. Cupid
$
$ CALPHAD: Computer Coupling of Phase Diagrams and Thermochemistry
$ 47 (2014) 181-195
$ ------------------------------------------------------------------------------
 ELEMENT /-   ELECTRON_GAS              0.0000E+00  0.0000E+00  0.0000E+00!
 ELEMENT VA   VACUUM                    0.0000E+00  0.0000E+00  0.0000E+00!
 ELEMENT LI   BCC_A2                    6.9410E+00  4.6233E+03  2.9095E+01 !
 ELEMENT SN   BCT_A5                    1.1871E+02  6.3220E+03  5.1195E+01 !

 SPECIES LI4SN                          LI4SN1 !
$ ------------------------------------------------------------------------------
 TYPE_DEFINITION % SEQ *!
 DEFINE_SYSTEM_DEFAULT ELEMENT 2 !
 DEFAULT_COMMAND DEF_SYS_ELEMENT VA /- !

$ ------------------------------------------------------------------------------
$ Li
$ ------------------------------------------------------------------------------
$ Unary 5.1
 FUNCTION GHSERLI  200.00
 -10583.817+217.637482*T-38.940488*T*LN(T)+35.466931E-3*T**2-19.869816E-6*T**3
 +159994*T**(-1);   453.60 Y
 -559579.123+10547.879893*T-1702.8886493*T*LN(T)+2258.329444E-3*T**2
 -571.066077E-6*T**3+33885874*T**(-1);   500.00 Y
 -9062.994+179.278285*T-31.2283718*T*LN(T)+2.633221E-3*T**2-0.438058E-6*T**3
 -102387*T**(-1);  3000.00 N !

 FUNCTION GLIQLI   200.00
 -7883.612+211.841861*T-38.940488*T*LN(T)+35.466931E-3*T**2-19.869816E-6*T**3
 +159994*T**(-1);   250.00 Y
 12015.027-362.187078*T+61.6104424*T*LN(T)-182.426463E-3*T**2+63.955671E-6*T**3
 -559968*T**(-1);   453.60 Y
 -6057.31+172.652183*T-31.2283718*T*LN(T)+2.633221E-3*T**2-0.438058E-6*T**3
 -102387*T**(-1);  3000.00 N !

 FUNCTION GFCCLI 200 -108+1.3*T+GHSERLI; 3000 N !

 FUNCTION GHCPLI 200 -154+2*T+GHSERLI; 3000 N !
$ ------------------------------------------------------------------------------
$ Sn
$ ------------------------------------------------------------------------------
$ Unary 5.1
 FUNCTION GHSERSN  100.00
 -7958.517+122.765451*T-25.858*T*LN(T)+0.51185E-3*T**2-3.192767E-6*T**3
 +18440*T**(-1);   250.00 Y
 -5855.135+65.443315*T-15.961*T*LN(T)-18.8702E-3*T**2+3.121167E-6*T**3
 -61960*T**(-1);   505.078 Y
 2524.724+4.005269*T-8.2590486*T*LN(T)-16.814429E-3*T**2+2.623131E-6*T**3
 -1081244*T**(-1)-123.07E23*T**(-9);   800.00 Y
 -8256.959+138.99688*T-28.4512*T*LN(T)-123.07E23*T**(-9);  3000.00 N !

 FUNCTION GLIQSN 100 7103.092-14.087767*T+147.031E-20*T**7+GHSERSN; 505.078 Y
 9496.31-9.809114*T-8.2590486*T*LN(T)-16.814429E-3*T**2+2.623131E-6*T**3
 -1081244*T**(-1);   800.00 Y
 -1285.372+125.182498*T-28.4512*T*LN(T);  3000.00 N !

 FUNCTION GFCCSN 100 5510-8.46*T+GHSERSN; 3000 N !

 FUNCTION GHCPSN 100 3900-7.646*T+GHSERSN; 3000 N !

 FUNCTION GBCCSN 100 4400-6*T+GHSERSN; 3000 N !

 FUNCTION GDIASN 0  100
 -9579.608+114.007785*T-22.972*T*LN(T)-8.13975E-3*T**2+2.7288E-6*T**3
 +25615*T**(-1);   298.15 Y
 -9063.001+104.84654*T-21.5750771*T*LN(T)-8.575282E-3*T**2+1.784447E-6*T**3
 -2544*T**(-1);   800.00 Y
 -10909.353+147.396537*T-28.4512*T*LN(T);  3000.00 N !
$ ------------------------------------------------------------------------------
$ PARAMETERS FOR LIQUID PHASE
$ ------------------------------------------------------------------------------
 PHASE LIQUID % 1 1 !
 CONSTITUENT LIQUID : LI, LI4SN, SN : !
 PARAMETER G(LIQUID,LI;0) 298.15 +GLIQLI;                              3000 N !
 PARAMETER G(LIQUID,SN;0) 298.15 +GLIQSN;                              3000 N !
 PARAMETER G(LIQUID,LI4SN;0) 298.15 -205264.343+187.457195*T-16.7055876*T*LN(T)
 +4*GLIQLI+GLIQSN;                                                      3000 N !
 PARAMETER G(LIQUID,LI,SN;0) 298.15 -64124.4038-15.9626763*T
 +2.04164413*T*LN(T) ;                                                 3000 N !
 PARAMETER G(LIQUID,LI,LI4SN,SN;0) 298.15 30074.1641-19.0031351*T
 -1.46094182*T*LN(T) ;                                                 3000 N !
 PARAMETER G(LIQUID,LI4SN,SN;0) 298.15 -24652.1452-259.57801*T
 +28.4690441*T*LN(T) ;                                                 3000 N !
$ ------------------------------------------------------------------------------
$ PARAMETERS FOR BCC PHASE
$ ------------------------------------------------------------------------------
 PHASE BCC % 1 1 !
 CONSTITUENT BCC : LI, SN : !
 PARAMETER G(BCC,LI;0) 298.15 +GHSERLI;                                3000 N !
 PARAMETER G(BCC,SN;0) 298.15 +GBCCSN;                                 3000 N !
$ ------------------------------------------------------------------------------
$ PARAMETERS FOR BCT PHASE
$ ------------------------------------------------------------------------------
 PHASE BCT % 1 1 !
 CONSTITUENT BCT : SN : !
 PARAMETER G(BCT,SN;0) 298.15 +GHSERSN;                                3000 N !
$ ------------------------------------------------------------------------------
$ PARAMETERS FOR DIAMOND PHASE
$ ------------------------------------------------------------------------------
 PHASE DIAMOND % 1 1 !
 CONSTITUENT DIAMOND : SN : !
 PARAMETER G(DIAMOND,SN;0) 298.15 +GDIASN;                         3000 N !
$ ------------------------------------------------------------------------------
$ PARAMETERS FOR STOICHIOMETRIC PHASE
$ ------------------------------------------------------------------------------
 PHASE LI17SN4 % 2 0.81 0.19 !
 CONSTITUENT LI17SN4 : LI : SN : !
 PARAMETER G(LI17SN4,LI:SN;0) 298.15
 -47307.6838+168.904051*T-29*T*LN(T);                              3000 N !

 PHASE LI7SN2 % 2 0.778 0.222 !
 CONSTITUENT LI7SN2 : LI,SN : SN : !
 PARAMETER G(LI7SN2,LI:SN;0) 298.15 -48940+167.201983*T-29*T*LN(T); 3000 N !
 PARAMETER G(LI7SN2,SN:SN;0) 298.15 +5000;                  3000 N !
 PARAMETER G(LI7SN2,LI,SN:SN;0) 298.15 0;                           3000 N !
 PARAMETER G(LI7SN2,LI,SN:SN;1) 298.15 -130*T;                      3000 N !

 PHASE LI13SN5 % 2 0.722 0.278 !
 CONSTITUENT LI13SN5 : LI : SN : !
 PARAMETER G(LI13SN5,LI:SN;0) 298.15 -51045+166.043371*T-29*T*LN(T); 3000 N !

 PHASE LI5SN2 % 2 0.714 0.286 !
 CONSTITUENT LI5SN2 : LI : SN : !
 PARAMETER G(LI5SN2,LI:SN;0) 298.15 -50890+165.654838*T-29*T*LN(T);  3000 N !

 PHASE LI7SN3 % 2 0.7 0.3 !
 CONSTITUENT LI7SN3 : LI : SN : !
 PARAMETER G(LI7SN3,LI:SN;0) 298.15 -50500+165.335224*T-29*T*LN(T); 3000 N !

 PHASE LISN % 2 0.5 0.5 !
 CONSTITUENT LISN : LI : SN : !
 PARAMETER G(LISN,LI:SN;0) 298.15 -41200+156.993388*T-29*T*LN(T);  3000 N !

 PHASE LI2SN5 % 2 0.286 0.714 !
 CONSTITUENT LI2SN5 : LI : SN : !
 PARAMETER G(LI2SN5,LI:SN;0) 298.15 -33000+158.281465*T-29*T*LN(T); 3000 N !
$ ----------------------------------------------------------------- END OF LINE
$
"""


LI_SN_ZPF_DATA = {
    "components": ["LI", "SN"],
    "phases": ["LIQUID", "LI7SN2"],
    "broadcast_conditions": False,
    "conditions": {
        "T": [1040],
        "P": [101325.0]
    },
    "output": "ZPF",
    "values": [
        [["LIQUID", ["SN"], [0.25864665]], ["LI7SN2", ["SN"], [0.24402028]]]
    ],
    "reference": "zpf test", "comment": "Exact tieline based on equilibrium calculation"
}


LI_SN_LIQUID_DATA = {
    "components": ["LI", "SN"],
    "phases": ["LIQUID"],
    "solver": {
        "mode": "manual",
        "sublattice_site_ratios": [1],
        "sublattice_configurations": [[["LI", "LI4SN"]], [["LI4SN", "SN"]]],
        "sublattice_occupancies": [[[0.5, 0.5]], [[0.5, 0.5]]]
    },
    "conditions": {"P": 101325, "T": 300},
    "output": "HM_MIX",
    "values": [[[0, 0]]],
    "reference": "non-equilibrium thermochemical tests", "comment": "Valid speices: LI, LI4SN, SN; No interaction for LI/LI4SN, but there is one for LI4SN/SN"
}

LI_SN_LIQUID_EQ_DATA = {
    "components": ["LI", "SN"],
    "phases": ["LIQUID"],
    "conditions": {"P": 101325, "T": 300, "X_LI": [0.0, 0.5, 0.8, 1.0]},
    "reference_states": {
        "LI": {"phase": "LIQUID"},
        "SN": {"phase": "LIQUID"}
    },
    "output": "HMR",
    "values": [[[0, 0, 0, 0]]],
    "reference": "equilibrium thermochemical tests", "comment": "Valid speices: LI, LI4SN, SN; No interaction for LI/LI4SN, but there is one for LI4SN/SN. True values should be [0.0, -28133.588, -40049.995, 0.0]"
}

SGTE91_PURE_ELEMENTS = (
    '/-', 'VA', 'AG', 'AL', 'AM', 'AS', 'AU', 'B', 'BA', 'BE', 'BI', 'C', 'CA',
     'CD', 'CE', 'CO', 'CR', 'CS', 'CU', 'DY', 'ER', 'EU', 'FE', 'GA', 'GD',
     'GE', 'HF', 'HG', 'HO', 'IN', 'IR', 'K', 'LA', 'LI', 'LU', 'MG', 'MN',
     'MO', 'N', 'NA', 'NB', 'ND', 'NI', 'NP', 'O', 'OS', 'P', 'PA', 'PB', 'PD',
      'PR', 'PT', 'PU', 'RB', 'RE', 'RH', 'RU', 'S', 'SB', 'SC', 'SE', 'SI',
      'SM', 'SN', 'SR', 'TA', 'TB', 'TC', 'TE', 'TH', 'TI', 'TL', 'TM', 'U',
      'V', 'W', 'Y', 'YB', 'ZN', 'ZR',
)